/*
*************************************************
* Programe name: 3-1.cpp
* Author:		 Seif Azghandi
* Date written:	 02/08/2007
* Programe description:
*		This program count words using a vector of
*		structs.
*************************************************
*/

//Define header files

#include <iostream>
#include <vector>
#include <string>

// Define utility classes and methods

using std::cout;
using std::cin;
using std::endl;
using std::string;
using std::vector;

// Define the User Defined Data (UDT) type.

typedef struct Bundled
{
	string in;
	string out;
	int num_out;
} bundled;

// Display vectors (function declaration).
.
void show_vec(const vector<Bundled>&);


/*
***************
*	The driver
***************
*/
int main()
{
	//Create the vector of struct and a temporary struct variable.
	vector<Bundled> thingy;
	int count=0;
	Bundled temp;

	//Prompt the user to enter words terminated by pressing <CTRL>+D
	cout<<"Please enter input to be evalulated, to terminate press <ENTER> <CTRL>+<D>: \n";

	//Capture input in the "in" string of the vector struct.
	while(cin >> temp.in)
		thingy.push_back(temp);

	//The following nested for loop does the followings:
	//     - Moves the "in" string to "out" sring and keep a count.
	//	   - It clears the processed words (leaves lot of holes; swiss cheese).
	//	   - At the end, all the "in's" are transferred to "out's" with proper counts.

	for(int i=0;i<thingy.size();i++)
	{
		for(int j=i;j<thingy.size();j++)
		{
			if(!thingy[j].in.empty() && thingy[i].in == thingy[j].in)
			{
				count++;
				if(count==1)
				{
					thingy[i].out = thingy[j].in;
				}
				else
					thingy[j].in.clear();
			}
		}
		thingy[i].in.clear();
		thingy[i].num_out = count;
		count=0;
	}

	// Display the vector (only the out's and counts.
	show_vec(thingy);

	return 0;
}

// Display vectors (function definition).

void show_vec(const vector<Bundled>& vec)
{
	for(int i=0; i<vec.size();i++)
	{
		if(!vec[i].out.empty())
			cout<<vec[i].out<<": "<<vec[i].num_out<<endl;
	}
}
